#!/usr/local/bin/python

# Author                 Version      Date
# -----------------------------------------------
# S M Crawford (SAAO)    1.0          10 Jan 2008

# saltmysql are salt tasks associated with connecting to and 
# accessessing a mysql server database.


import saltprint
import os, sys, string 
import MySQLdb

# -----------------------------------------------------------
# Connect to  a database 

def connectdb(host,dbname,user,passwd,logfile):
    db=''
    status = 0
    try:
        db = MySQLdb.connect(host=host,db=dbname,user=user,passwd=passwd)
    except:
        message = 'ERROR: SALTMYSQL.CONNECTDB -- Cannot connect to ' + host
        status = saltprint.err(logfile,message)

    return db,status

#-----------------------------------------------------------
# Select a record from a table 

def select(db, selection, table, logic, logfile):
    status=0
    record=''
    try:
	exec_command    =""
        exec_command   +="SELECT "+selection
        exec_command   +=" FROM  "+table 
	if len(logic)>0:
         exec_command   +=" WHERE  "+logic 

	cursor = db.cursor()
	cursor.execute(exec_command)
	record = cursor.fetchall()
	cursor.close()
	
    except:
	   message = 'ERROR: SALTMYSQL.SELECT -- Cannot read value '
           status = saltprint.err(logfile,message)

    return record, status

#-----------------------------------------------------------
# Insert a record into the table

def insert(db, insertion, table, logfile):
    status=0
    try:
        exec_command    =""
        exec_command   +="INSERT INTO "+table
        exec_command   +=" SET  "+insertion


        cursor = db.cursor()
        cursor.execute(exec_command)
        cursor.execute("COMMIT")

    except Exception, inst: 
           message = 'ERROR: SALTMYSQL.INSERT -- Cannot insert into ' + table + '\n'
	   message = message + inst[1]
           status = saltprint.err(logfile,message)

    return status

#-----------------------------------------------------------
# update a record in a table

def update(db, insertion, table, logic, logfile):
    status=0
    try:
        exec_command    =""
        exec_command   +="UPDATE "+table
        exec_command   +=" SET  "+insertion
	if len(logic)>0:
         exec_command   +=" WHERE  "+logic 


        cursor = db.cursor()
        cursor.execute(exec_command)
        cursor.execute("COMMIT")

    except Exception, inst:
           message = 'ERROR: SALTMYSQL.INSERT -- Cannot insert into ' + table + '\n'
           message = message + inst[1]
           status = saltprint.err(logfile,message)

    return status

#-----------------------------------------------------------
# delete a record in a table

def delete(db, table,logic, logfile):
    status=0
    try:
        exec_command    =""
        exec_command   +="DELETE FROM "+table
	if len(logic)>0:
         exec_command   +=" WHERE "+logic 


        cursor = db.cursor()
        cursor.execute(exec_command)
        cursor.execute("COMMIT")

    except Exception, inst:
           message = 'ERROR: SALTMYSQL.DELETE -- Cannot delete  entry in ' + table + '\n'
           message = message + inst
           status = saltprint.err(logfile,message)

    return status

#-----------------------------------------------------------
# create a new fits file entry in the FileData table

def createnewFileData(db, ImageHeader, FileNameString, PipelineFileNameString, logfile):
    from salttime import datatimeobs2DateTime,sex2dec
    status=0
    message=''
    except_message=''
    UTStartString='1000-01-01 00:00:00'
    ExposureTimeString=''
    TelRAString=''
    TelDecString=''
    TelEpochString=''
    PipelineStartString='1000-01-01 00:00:00'
    try:
     UTStartString=ImageHeader['DATE-OBS']+' '+ImageHeader['UTC-OBS']
     ExposureTimeString='%5.3f' % ImageHeader['EXPTIME']
     TelRA=15.0*sex2dec(ImageHeader['TELRA'])
     TelDec=sex2dec(ImageHeader['TELDEC'])
     TelRAString='%10.7f' % TelRA
     TelDecString='%10.7f' % TelDec
     TelEpochString='%6.2f' % ImageHeader['EQUINOX']
     PipelineStartString=datatimeobs2DateTime(ImageHeader['SAL-TLM'])
    except Exception, inst:
	except_message=inst[0]


    insert_command='ObsStats_Id=2,Track_Id=1,'
    insert_command += "UTStart='"+UTStartString+"',"
    insert_command += "ExposureTime='"+ExposureTimeString+"',"
    insert_command += "TelRA='"+TelRAString+"',"
    insert_command += "TelDec='"+TelDecString+"',"
    insert_command += "TelEpoch='"+TelEpochString+"',"
    insert_command += "FileName='"+FileNameString+"',"
    insert_command += "PipelineDate='"+PipelineStartString+"',"
    insert_command += "PipelineFileName='"+PipelineFileNameString+"'"

    status=insert(db,insert_command,'FileData',logfile)

    if status==0:
	message='SALTMYSQL.CREATENEWFILEDATA -- Created entry in FileData for ' + FileNameString
	saltprint.log(logfile,message,True)
    else:
       message = 'ERROR: SALTMYSQL.CREATENEWFILEDATA -- Cannot create entry ' + \
		FileNameString + ' in FileData \n'
       message = message + except_message
       status = saltprint.err(logfile,message)
	
    return status

